/*
 * Copyright 2016 Google Inc. All Rights Reserved.
 *
 * This code is confidential and provided to Android partners under NDA. You may modify, compile and
 * distribute the compiled code with your management software to assist with the provisioning and
 * management of Android devices. Other uses require written permission.
 */
package com.google.android.apps.work.dpcsupport;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.os.Messenger;

/**
 * Proxy service for application restrictions.
 *
 * <p>Before Android N, only the DPC has permission to set application restrictions. To enable the
 * Play Store to manage the application restrictions, a bound service is used to pass them to
 * {@link ManagedConfigurationsProxy}.
 */
public class ManagedConfigurationsProxy extends Service {

  private Messenger mMessenger;

  @Override
  public void onCreate() {
    this.mMessenger = new Messenger(new ManagedConfigurationsProxyHandler(getApplicationContext()));
  }

  @Override
  public IBinder onBind(Intent intent) {
    return mMessenger.getBinder();
  }
}
