// Generated with go/better-aidl
package com.google.android.finsky.services;

import android.os.Bundle;
import android.os.IBinder;
import android.os.IInterface;
import android.os.Parcel;
import android.os.RemoteException;
import com.google.android.aidl.BaseProxy;
import com.google.android.aidl.BaseStub;
import com.google.android.aidl.Codecs;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import javax.annotation.Generated;

/**
 * An interface to the PackageUpdateService. This is an entry point used to request an update of
 * an installed package.
 */
@Generated("//java/com/google/android:aidl")
@SuppressWarnings({
    "unchecked",
    "rawtypes"
})
public interface IPackageUpdateService extends IInterface {
  /**
   * Request for a package to be updated. This can only be called by the device or profile owner,
   * and is limited to a whitelist of packages which can be updated.
   *
   * If this call is successful, it is guaranteed that a PackageInstaller session has been created
   * which can be used to track the status.
   *
   * The extras bundle may contain the following:
   * unauthenticated
   * A boolean indicating whether to explicitly trigger an unauthenticated update.
   *
   * The returned bundle contains the following:
   * success
   * A string indicating whether the request to update the package was successful.
   *
   * @param packageName the package to update
   * @param extras bundle containing additional information about the package update. Currently
   * this is not used.
   *
   * @return bundle containing information about the package being updated
   */
  Bundle updatePackage(String packageName, Bundle extras) throws RemoteException;

  abstract class Stub extends BaseStub implements IPackageUpdateService {
    private static final String DESCRIPTOR = "com.google.android.finsky.services.IPackageUpdateService";

    static final int TRANSACTION_updatePackage = IBinder.FIRST_CALL_TRANSACTION + 1;

    public Stub() {
      super(DESCRIPTOR);
    }

    public static IPackageUpdateService asInterface(IBinder obj) {
      if (obj == null) {
        return null;
      }
      IInterface iin = obj.queryLocalInterface(DESCRIPTOR);
      if (iin instanceof IPackageUpdateService) {
        return (IPackageUpdateService) iin;
      }
      return new Proxy(obj);
    }

    @Override
    protected boolean dispatchTransaction(int code, Parcel data, Parcel reply, int flags) throws
        RemoteException {
      if (code == TRANSACTION_updatePackage) {
        String packageName = data.readString();
        Bundle extras = Codecs.createParcelable(data, Bundle.CREATOR);
        Bundle retval = updatePackage(packageName, extras);
        reply.writeNoException();
        Codecs.writeParcelableAsReturnValue(reply, retval);
        return true;
      } else {
        return false;
      }
    }

    public static class Proxy extends BaseProxy implements IPackageUpdateService {
      Proxy(IBinder remote) {
        super(remote, DESCRIPTOR);
      }

      @Override
      public Bundle updatePackage(String packageName, Bundle extras) throws RemoteException {
        Parcel data = obtainAndWriteInterfaceToken();
        data.writeString(packageName);
        Codecs.writeParcelable(data, extras);
        Parcel reply = transactAndReadException(TRANSACTION_updatePackage, data);
        Bundle retval = Codecs.createParcelable(reply, Bundle.CREATOR);
        reply.recycle();
        return retval;
      }
    }
  }
}
